## bppsuite 0.6.2

=== CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Author: Julien Dutheil
# Created: 22/08/2009

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)
PROJECT(bppsuite CXX)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF()

SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
IF(NOT NO_VIRTUAL_COV)
  SET(NO_VIRTUAL_COV FALSE CACHE BOOL
      "Disable covariant return type with virtual inheritance, for compilers that do not support it."
      FORCE)
ENDIF()

IF(NO_VIRTUAL_COV)
  MESSAGE("-- Covariant return with virtual inheritance disabled.")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_VIRTUAL_COV=1")
ENDIF()

IF(NOT NO_DEP_CHECK)
  SET(NO_DEP_CHECK FALSE CACHE BOOL
      "Disable dependencies check for building distribution only."
      FORCE)
ENDIF(NOT NO_DEP_CHECK)

IF(NO_DEP_CHECK)
  MESSAGE("-- Dependencies checking disabled. Only distribution can be built.")
ELSE(NO_DEP_CHECK)

#static linkage?
IF(NOT BUILD_STATIC)
  SET(BUILD_STATIC FALSE CACHE BOOL
      "Enable static linkage."
      FORCE)
ENDIF()
IF(BUILD_STATIC)
  MESSAGE("-- Static linkage requested.")
  SET(CMAKE_CXX_FLAGS "-static -static-libgcc ${CMAKE_CXX_FLAGS}")
ENDIF()

#build info?
IF(NOT DEFINED INFO)
  SET(INFO UNIX)
ENDIF(NOT DEFINED INFO)

#build man pages?
IF(NOT DEFINED MAN)
  SET(MAN UNIX)
ENDIF(NOT DEFINED MAN)

#find executables for documentation
FIND_PROGRAM(MAKEINFO_EXE NAMES makeinfo)
FIND_PROGRAM(PDFTEX_EXE NAMES pdftex)
FIND_PROGRAM(NROFF_EXE NAMES nroff)

#here is a useful function:
MACRO(IMPROVED_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})

  IF(BUILD_STATIC)
    SET(${lib_name}_STATIC_NAMES lib${lib_name}.a)
    FIND_LIBRARY(${lib_name}_STATIC_LIBRARY NAMES ${${lib_name}_STATIC_NAMES} PATH_SUFFIXES lib${LIB_SUFFIX})
    IF(${lib_name}_STATIC_LIBRARY)
      MESSAGE("-- Library ${lib_name} found here:")
      MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
      MESSAGE("   static libraries: ${${lib_name}_STATIC_LIBRARY}")
    ELSE()
      MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
    ENDIF()
    #add the dependency:
    SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_STATIC_LIBRARY})
  ELSE()
    SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
    FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES} PATH_SUFFIXES lib${LIB_SUFFIX})
    IF(${lib_name}_LIBRARY)
      MESSAGE("-- Library ${lib_name} found here:")
      MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
      MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    ELSE()
      MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
    ENDIF()
    #add the dependency:
    SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
  ENDIF()
  
ENDMACRO(IMPROVED_FIND_LIBRARY)

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)

#Find the libraries. The order is very important for static linkage, it won't
#link if you change it!
IMPROVED_FIND_LIBRARY(LIBS bpp-phyl Bpp/Phyl/Tree.h)
IMPROVED_FIND_LIBRARY(LIBS bpp-seq Bpp/Seq/Alphabet/Alphabet.h)
IMPROVED_FIND_LIBRARY(LIBS bpp-core Bpp/Clonable.h)

IF(MAKEINFO_EXE)
  MESSAGE("-- Found makeinfo here: ${MAKEINFO_EXE}")
  MESSAGE("   Adding targets: info, html")

  IF(INFO)
    SET(ADD_INFO_TO "ALL")
    MESSAGE("   Adding target info to target all")
  ENDIF(INFO)

  ADD_CUSTOM_TARGET(info
    ${ADD_INFO_TO}
    COMMAND ${MAKEINFO_EXE} bppsuite.texi
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
    )

  ADD_CUSTOM_TARGET(html
    COMMAND ${MAKEINFO_EXE} --html --css-ref=http://www.w3.org/StyleSheets/Core/Steely bppsuite.texi
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
    )
ENDIF(MAKEINFO_EXE)

IF(PDFTEX_EXE)
  MESSAGE("-- Found pdftex here: ${PDFTEX_EXE}")
  MESSAGE("   Adding target: pdf")

  ADD_CUSTOM_TARGET(pdf
    COMMAND ${PDFTEX_EXE} bppsuite.texi
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
    )
  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc/bppsuite.pdf;doc/bppsuite.aux;doc/bppsuite.cp;doc/bppsuite.fn;doc/bppsuite.info;doc/bppsuite.ky;doc/bppsuite.log;doc/bppsuite.pg;doc/bppsuite.toc;doc/bppsuite.tp;doc/bppsuite.vr")
ENDIF(PDFTEX_EXE)

IF(NROFF_EXE)
  MESSAGE("-- Found nroff here: ${NROFF_EXE}")
  MESSAGE("   Adding targets: man")

  ADD_CUSTOM_TARGET(man
    ALL
    COMMAND cp bppml.1.txt bppml.1
    COMMAND gzip -f bppml.1
    COMMAND cp bppseqgen.1.txt bppseqgen.1
    COMMAND gzip -f bppseqgen.1
    COMMAND cp bppdist.1.txt bppdist.1
    COMMAND gzip -f bppdist.1
    COMMAND cp bpppars.1.txt bpppars.1
    COMMAND gzip -f bpppars.1
    COMMAND cp bppseqman.1.txt bppseqman.1
    COMMAND gzip -f bppseqman.1
    COMMAND cp bppconsense.1.txt bppconsense.1
    COMMAND gzip -f bppconsense.1
    COMMAND cp bppancestor.1.txt bppancestor.1
    COMMAND gzip -f bppancestor.1
    COMMAND cp bppreroot.1.txt bppreroot.1
    COMMAND gzip -f bppreroot.1
    COMMAND cp bppphysamp.1.txt bppphysamp.1
    COMMAND gzip -f bppphysamp.1
    COMMAND cp bpptreedraw.1.txt bpptreedraw.1
    COMMAND gzip -f bpptreedraw.1
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/man
    )
  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "man/bppml.1.gz;man/bppseqgen.1.gz;man/bppdist.1.gz;man/bpppars.1.gz;man/bppseqman.1.gz;man/bppconsense.1.gz;man/bppancestor.1.gz;man/bppreroot.1.gz;man/bppphysamp.1.gz;man/bpptreedraw.1.gz")
ENDIF(NROFF_EXE)

# Subdirectories
ADD_SUBDIRECTORY(bppSuite)
ADD_SUBDIRECTORY(doc)
ADD_SUBDIRECTORY(man)

ENDIF(NO_DEP_CHECK)

# Packager
SET(CPACK_PACKAGE_NAME "bppsuite")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "0.6.2")
SET(CPACK_PACKAGE_VERSION_MAJOR "0")
SET(CPACK_PACKAGE_VERSION_MINOR "6")
SET(CPACK_PACKAGE_VERSION_PATCH "2")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.cmake"
 ".*\\\\.svn"
 ".*\\\\.gz"
 ".*\\\\.zip"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\.sh"
 ".*\\\\..*\\\\.swp"
 ".*stamp"
 "\\\\.sh"
 "bppSuite/\\\\..*"
 "bppSuite/bppancestor"
 "bppSuite/bppml"
 "bppSuite/bppphysamp"
 "bppSuite/bppseqman"
 "bppSuite/bppconsense"
 "bppSuite/bppreroot"
 "bppSuite/bpppars"
 "bppSuite/bpptreedraw"
 "bppSuite/bppdist"
 "bppSuite/bppseqgen"
 "doc/bppsuite/"
 "doc/bppsuite\\\\.info"
 "doc/bppsuite\\\\.toc"
 "doc/bppsuite\\\\.vr"
 "doc/bppsuite\\\\.tp"
 "doc/bppsuite\\\\.log"
 "doc/bppsuite\\\\.fn"
 "doc/bppsuite\\\\.ky"
 "doc/bppsuite\\\\.cp"
 "doc/bppsuite\\\\.pg"
 "doc/bppsuite\\\\.aux"
 "doc/bppsuite\\\\.pdf"
 "man/.*\\\\.1.gz"
 "debian/tmp"
 "debian/bppsuite/"
 "debian/bppsuite\\\\.substvars"
 "debian/bppsuite\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)
IF (MACOS)
  SET(CPACK_GENERATOR "Bundle")
ENDIF()

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
INCLUDE(CPack)

#This adds the 'dist' target
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF(NOT NO_DEP_CHECK)
IF (UNIX)
#This creates deb packages:
ADD_CUSTOM_TARGET(origdist COMMAND cp ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz ../${CPACK_DEBSOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(origdist dist)
ADD_CUSTOM_TARGET(deb dpkg-buildpackage -uc -us -i${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(deb origdist)
ADD_DEPENDENCIES(deb info man)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist info man)

#ADD_DEPENDENCIES(info install)

ENDIF(UNIX)

ENDIF(NOT NO_DEP_CHECK)

=== bppSuite/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Author: Julien Dutheil
# Created: 22/08/2009

ADD_EXECUTABLE(bppml bppML.cpp)
TARGET_LINK_LIBRARIES(bppml ${LIBS})
SET_TARGET_PROPERTIES(bppml PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppseqgen bppSeqGen.cpp)
TARGET_LINK_LIBRARIES(bppseqgen ${LIBS})
SET_TARGET_PROPERTIES(bppseqgen PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppdist bppDist.cpp)
TARGET_LINK_LIBRARIES(bppdist ${LIBS})
SET_TARGET_PROPERTIES(bppdist PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bpppars bppPars.cpp)
TARGET_LINK_LIBRARIES(bpppars ${LIBS})
SET_TARGET_PROPERTIES(bpppars PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppseqman bppSeqMan.cpp)
TARGET_LINK_LIBRARIES(bppseqman ${LIBS})
SET_TARGET_PROPERTIES(bppseqman PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppconsense bppConsense.cpp)
TARGET_LINK_LIBRARIES(bppconsense ${LIBS})
SET_TARGET_PROPERTIES(bppconsense PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppancestor bppAncestor.cpp)
TARGET_LINK_LIBRARIES(bppancestor ${LIBS})
SET_TARGET_PROPERTIES(bppancestor PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppreroot bppReRoot.cpp)
TARGET_LINK_LIBRARIES(bppreroot ${LIBS})
SET_TARGET_PROPERTIES(bppreroot PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bppphysamp bppPhyloSampler.cpp)
TARGET_LINK_LIBRARIES(bppphysamp ${LIBS})
SET_TARGET_PROPERTIES(bppphysamp PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

ADD_EXECUTABLE(bpptreedraw bppTreeDraw.cpp)
TARGET_LINK_LIBRARIES(bpptreedraw ${LIBS})
SET_TARGET_PROPERTIES(bpptreedraw PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})

# Install progs
INSTALL(TARGETS
  bppml
  bppseqgen
  bppdist
  bpppars
  bppseqman
  bppconsense
  bppancestor
  bppreroot
  bppphysamp
  bpptreedraw
  DESTINATION bin)

=== man/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Author: Julien Dutheil
# Created: 22/08/2009

IF(MAN)
  INSTALL(FILES bppml.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppseqgen.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppancestor.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bpppars.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppdist.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppconsense.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppseqman.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppreroot.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bppphysamp.1.gz DESTINATION share/man/man1)
  INSTALL(FILES bpptreedraw.1.gz DESTINATION share/man/man1)
ENDIF(MAN)

=== debian/changelog ===
bppsuite (0.6.2-1) unstable; urgency=low

  * RFP: Bio++ -- The Bio++ bioinformatics libraries. (Closes: #616373).
  * Packages are now non-native.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Thu, 09 Jun 2011 11:00:00 +0100

bppsuite (0.6.1) unstable; urgency=low

  * Compatibility update with bpp-phyl 2.0.1.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Mon, 28 Feb 2011 09:00:00 +0100

bppsuite (0.6.0) unstable; urgency=low

  * Compatibility update with Bio++ 2.0.0.
  * New mixed substitution models.
  * More sequence manipulation tools.
  * Several bug fixed and syntax improvements.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Mon, 07 Feb 2011 09:00:00 +0100

bppsuite (0.5.0) unstable; urgency=low

  * New substitution models.
  * New tree drawing program.
  * Compatibility update with Bio++ 1.9.0.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Thu, 25 Mar 2010 21:17:37 +0100

bppsuite (0.4.0) unstable; urgency=low

  * Major syntax update, using keyvals.
  * Compatibility update with Bio++ 1.8.0.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Wed, 10 Jun 2009 11:28:58 +0100

bppsuite (0.3.1) unstable; urgency=low

  * Several bug fixed.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Thu, 11 Dec 2008 12:21:37 +0100

bppsuite (0.3.0) unstable; urgency=low

  * Initial release

 -- Julien Dutheil <jdutheil@birc.au.dk>  Fri, 25 Sep 2008 14:28:21 +0200

## bppsuite 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -164,9 +164,11 @@
     COMMAND gzip -f bppphysamp.1
     COMMAND cp bpptreedraw.1.txt bpptreedraw.1
     COMMAND gzip -f bpptreedraw.1
+    COMMAND cp bppalnscore.1.txt bppalnscore.1
+    COMMAND gzip -f bppalnscore.1
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/man
     )
-  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "man/bppml.1.gz;man/bppseqgen.1.gz;man/bppdist.1.gz;man/bpppars.1.gz;man/bppseqman.1.gz;man/bppconsense.1.gz;man/bppancestor.1.gz;man/bppreroot.1.gz;man/bppphysamp.1.gz;man/bpptreedraw.1.gz")
+  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "man/bppml.1.gz;man/bppseqgen.1.gz;man/bppdist.1.gz;man/bpppars.1.gz;man/bppseqman.1.gz;man/bppconsense.1.gz;man/bppancestor.1.gz;man/bppreroot.1.gz;man/bppphysamp.1.gz;man/bpptreedraw.1.gz;man/bppalnscore.1.gz")
 ENDIF(NROFF_EXE)
 
 # Subdirectories
@@ -179,10 +181,10 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "bppsuite")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "0.6.2")
+SET(CPACK_PACKAGE_VERSION "0.7.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-SET(CPACK_PACKAGE_VERSION_MINOR "6")
-SET(CPACK_PACKAGE_VERSION_PATCH "2")
+SET(CPACK_PACKAGE_VERSION_MINOR "7")
+SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
@@ -215,6 +217,7 @@
  "bppSuite/bpptreedraw"
  "bppSuite/bppdist"
  "bppSuite/bppseqgen"
+ "bppSuite/bppalnscore"
  "doc/bppsuite/"
  "doc/bppsuite\\\\.info"
  "doc/bppsuite\\\\.toc"

=== bppSuite/CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,10 @@
 TARGET_LINK_LIBRARIES(bpptreedraw ${LIBS})
 SET_TARGET_PROPERTIES(bpptreedraw PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})
 
+ADD_EXECUTABLE(bppalnscore bppAlnScore.cpp)
+TARGET_LINK_LIBRARIES(bppalnscore ${LIBS})
+SET_TARGET_PROPERTIES(bppalnscore PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})
+
 # Install progs
 INSTALL(TARGETS
   bppml
@@ -54,4 +58,5 @@
   bppreroot
   bppphysamp
   bpptreedraw
+  bppalnscore
   DESTINATION bin)

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -13,4 +13,5 @@
   INSTALL(FILES bppreroot.1.gz DESTINATION share/man/man1)
   INSTALL(FILES bppphysamp.1.gz DESTINATION share/man/man1)
   INSTALL(FILES bpptreedraw.1.gz DESTINATION share/man/man1)
+  INSTALL(FILES bppalnscore.1.gz DESTINATION share/man/man1)
 ENDIF(MAN)

## bppsuite 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Created: 22/08/2009
 
 # Global parameters
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
 PROJECT(bppsuite CXX)
 
 IF(NOT CMAKE_BUILD_TYPE)
@@ -12,7 +12,7 @@
       FORCE)
 ENDIF()
 
-SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
+SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow -Wconversion")
 IF(NOT NO_VIRTUAL_COV)
   SET(NO_VIRTUAL_COV FALSE CACHE BOOL
       "Disable covariant return type with virtual inheritance, for compilers that do not support it."
@@ -30,9 +30,23 @@
       FORCE)
 ENDIF(NOT NO_DEP_CHECK)
 
+IF(NOT DOC_COMPRESS)
+  SET(DOC_COMPRESS gzip CACHE STRING
+      "Set program for compressing documentation."
+      FORCE)
+ENDIF(NOT DOC_COMPRESS)
+
+IF(NOT DOC_COMPRESS_EXT)
+  SET(DOC_COMPRESS_EXT gz CACHE STRING
+      "Set extension of compressed documentation."
+      FORCE)
+ENDIF(NOT DOC_COMPRESS_EXT)
+
+
 IF(NO_DEP_CHECK)
   MESSAGE("-- Dependencies checking disabled. Only distribution can be built.")
 ELSE(NO_DEP_CHECK)
+
 
 #static linkage?
 IF(NOT BUILD_STATIC)
@@ -56,9 +70,82 @@
 ENDIF(NOT DEFINED MAN)
 
 #find executables for documentation
-FIND_PROGRAM(MAKEINFO_EXE NAMES makeinfo)
+IF(MAN)
+  FIND_PROGRAM(NROFF_EXE NAMES nroff)
+  IF(NROFF_EXE)
+    MESSAGE("-- Found nroff here: ${NROFF_EXE}")
+    MESSAGE("   Adding targets: man")
+
+    ADD_CUSTOM_TARGET(man
+      ALL
+      COMMAND cp bppml.1.txt bppml.1
+      COMMAND ${DOC_COMPRESS} -f bppml.1
+      COMMAND cp bppseqgen.1.txt bppseqgen.1
+      COMMAND ${DOC_COMPRESS} -f bppseqgen.1
+      COMMAND cp bppdist.1.txt bppdist.1
+      COMMAND ${DOC_COMPRESS} -f bppdist.1
+      COMMAND cp bpppars.1.txt bpppars.1
+      COMMAND ${DOC_COMPRESS} -f bpppars.1
+      COMMAND cp bppseqman.1.txt bppseqman.1
+      COMMAND ${DOC_COMPRESS} -f bppseqman.1
+      COMMAND cp bppconsense.1.txt bppconsense.1
+      COMMAND ${DOC_COMPRESS} -f bppconsense.1
+      COMMAND cp bppancestor.1.txt bppancestor.1
+      COMMAND ${DOC_COMPRESS} -f bppancestor.1
+      COMMAND cp bppreroot.1.txt bppreroot.1
+      COMMAND ${DOC_COMPRESS} -f bppreroot.1
+      COMMAND cp bppphysamp.1.txt bppphysamp.1
+      COMMAND ${DOC_COMPRESS} -f bppphysamp.1
+      COMMAND cp bpptreedraw.1.txt bpptreedraw.1
+      COMMAND ${DOC_COMPRESS} -f bpptreedraw.1
+      COMMAND cp bppalnscore.1.txt bppalnscore.1
+      COMMAND ${DOC_COMPRESS} -f bppalnscore.1
+      COMMAND cp bppmixedlikelihoods.1.txt bppmixedlikelihoods.1
+      COMMAND ${DOC_COMPRESS} -f bppmixedlikelihoods.1
+      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/man
+      )
+    SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "man/bppml.1.${DOC_COMPRESS_EXT};man/bppseqgen.1.${DOC_COMPRESS_EXT};man/bppdist.1.${DOC_COMPRESS_EXT};man/bpppars.1.${DOC_COMPRESS_EXT};man/bppseqman.1.${DOC_COMPRESS_EXT};man/bppconsense.1.${DOC_COMPRESS_EXT};man/bppancestor.1.${DOC_COMPRESS_EXT};man/bppreroot.1.${DOC_COMPRESS_EXT};man/bppphysamp.1.${DOC_COMPRESS_EXT};man/bpptreedraw.1.${DOC_COMPRESS_EXT};man/bppalnscore.1.${DOC_COMPRESS_EXT};man/bppmixedlikelihoods.1.${DOC_COMPRESS_EXT}")
+
+  ELSE()
+    MESSAGE(FATAL_ERROR "Program nroff required but not found.")
+  ENDIF()
+ENDIF(MAN)
+
+IF(INFO)
+  FIND_PROGRAM(MAKEINFO_EXE NAMES makeinfo)
+  IF(MAKEINFO_EXE)
+    MESSAGE("-- Found makeinfo here: ${MAKEINFO_EXE}")
+    MESSAGE("   Adding targets: info, html")
+ 
+    SET(ADD_INFO_TO "ALL")
+    MESSAGE("   Adding target info to target all")
+    
+    ADD_CUSTOM_TARGET(info
+      ${ADD_INFO_TO}
+      COMMAND ${MAKEINFO_EXE} bppsuite.texi
+      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
+      )
+
+    ADD_CUSTOM_TARGET(html
+      COMMAND ${MAKEINFO_EXE} --html --css-ref=http://www.w3.org/StyleSheets/Core/Steely bppsuite.texi
+      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
+      )
+  ELSE(MAKEINFO_EXE)
+    MESSAGE(FATAL_ERROR p"Program makeinfo required but not found.")
+  ENDIF(MAKEINFO_EXE)
+ENDIF(INFO)
+
 FIND_PROGRAM(PDFTEX_EXE NAMES pdftex)
-FIND_PROGRAM(NROFF_EXE NAMES nroff)
+IF(PDFTEX_EXE)
+  MESSAGE("-- Found pdftex here: ${PDFTEX_EXE}")
+  MESSAGE("   Adding target: pdf")
+
+  ADD_CUSTOM_TARGET(pdf
+    COMMAND ${PDFTEX_EXE} bppsuite.texi
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
+    )
+  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc/bppsuite.pdf;doc/bppsuite.aux;doc/bppsuite.cp;doc/bppsuite.fn;doc/bppsuite.info;doc/bppsuite.ky;doc/bppsuite.log;doc/bppsuite.pg;doc/bppsuite.toc;doc/bppsuite.tp;doc/bppsuite.vr")
+ENDIF(PDFTEX_EXE)
 
 #here is a useful function:
 MACRO(IMPROVED_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
@@ -106,71 +193,6 @@
 IMPROVED_FIND_LIBRARY(LIBS bpp-seq Bpp/Seq/Alphabet/Alphabet.h)
 IMPROVED_FIND_LIBRARY(LIBS bpp-core Bpp/Clonable.h)
 
-IF(MAKEINFO_EXE)
-  MESSAGE("-- Found makeinfo here: ${MAKEINFO_EXE}")
-  MESSAGE("   Adding targets: info, html")
-
-  IF(INFO)
-    SET(ADD_INFO_TO "ALL")
-    MESSAGE("   Adding target info to target all")
-  ENDIF(INFO)
-
-  ADD_CUSTOM_TARGET(info
-    ${ADD_INFO_TO}
-    COMMAND ${MAKEINFO_EXE} bppsuite.texi
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
-    )
-
-  ADD_CUSTOM_TARGET(html
-    COMMAND ${MAKEINFO_EXE} --html --css-ref=http://www.w3.org/StyleSheets/Core/Steely bppsuite.texi
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
-    )
-ENDIF(MAKEINFO_EXE)
-
-IF(PDFTEX_EXE)
-  MESSAGE("-- Found pdftex here: ${PDFTEX_EXE}")
-  MESSAGE("   Adding target: pdf")
-
-  ADD_CUSTOM_TARGET(pdf
-    COMMAND ${PDFTEX_EXE} bppsuite.texi
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc
-    )
-  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc/bppsuite.pdf;doc/bppsuite.aux;doc/bppsuite.cp;doc/bppsuite.fn;doc/bppsuite.info;doc/bppsuite.ky;doc/bppsuite.log;doc/bppsuite.pg;doc/bppsuite.toc;doc/bppsuite.tp;doc/bppsuite.vr")
-ENDIF(PDFTEX_EXE)
-
-IF(NROFF_EXE)
-  MESSAGE("-- Found nroff here: ${NROFF_EXE}")
-  MESSAGE("   Adding targets: man")
-
-  ADD_CUSTOM_TARGET(man
-    ALL
-    COMMAND cp bppml.1.txt bppml.1
-    COMMAND gzip -f bppml.1
-    COMMAND cp bppseqgen.1.txt bppseqgen.1
-    COMMAND gzip -f bppseqgen.1
-    COMMAND cp bppdist.1.txt bppdist.1
-    COMMAND gzip -f bppdist.1
-    COMMAND cp bpppars.1.txt bpppars.1
-    COMMAND gzip -f bpppars.1
-    COMMAND cp bppseqman.1.txt bppseqman.1
-    COMMAND gzip -f bppseqman.1
-    COMMAND cp bppconsense.1.txt bppconsense.1
-    COMMAND gzip -f bppconsense.1
-    COMMAND cp bppancestor.1.txt bppancestor.1
-    COMMAND gzip -f bppancestor.1
-    COMMAND cp bppreroot.1.txt bppreroot.1
-    COMMAND gzip -f bppreroot.1
-    COMMAND cp bppphysamp.1.txt bppphysamp.1
-    COMMAND gzip -f bppphysamp.1
-    COMMAND cp bpptreedraw.1.txt bpptreedraw.1
-    COMMAND gzip -f bpptreedraw.1
-    COMMAND cp bppalnscore.1.txt bppalnscore.1
-    COMMAND gzip -f bppalnscore.1
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/man
-    )
-  SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "man/bppml.1.gz;man/bppseqgen.1.gz;man/bppdist.1.gz;man/bpppars.1.gz;man/bppseqman.1.gz;man/bppconsense.1.gz;man/bppancestor.1.gz;man/bppreroot.1.gz;man/bppphysamp.1.gz;man/bpptreedraw.1.gz;man/bppalnscore.1.gz")
-ENDIF(NROFF_EXE)
-
 # Subdirectories
 ADD_SUBDIRECTORY(bppSuite)
 ADD_SUBDIRECTORY(doc)
@@ -181,9 +203,9 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "bppsuite")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "0.7.0")
+SET(CPACK_PACKAGE_VERSION "0.8.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-SET(CPACK_PACKAGE_VERSION_MINOR "7")
+SET(CPACK_PACKAGE_VERSION_MINOR "8")
 SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
@@ -230,7 +252,7 @@
  "doc/bppsuite\\\\.pg"
  "doc/bppsuite\\\\.aux"
  "doc/bppsuite\\\\.pdf"
- "man/.*\\\\.1.gz"
+ "man/.*\\\\.1.${DOC_COMPRESS_EXT}"
  "debian/tmp"
  "debian/bppsuite/"
  "debian/bppsuite\\\\.substvars"
@@ -245,10 +267,25 @@
 ENDIF()
 
 SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
 INCLUDE(CPack)
 
 #This adds the 'dist' target
-add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
+IF("${CMAKE_GENERATOR}" MATCHES "Make")
+  ADD_CUSTOM_TARGET(make_clean
+    COMMAND ${CMAKE_MAKE_PROGRAM} clean
+    WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
+  )
+  ADD_DEPENDENCIES(dist make_clean)
+
+  ADD_CUSTOM_TARGET(make_clean_man
+    COMMAND rm -f *.${DOC_COMPRESS_EXT}
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/man
+  )
+  ADD_DEPENDENCIES(dist make_clean_man)
+ENDIF()
 
 IF(NOT NO_DEP_CHECK)
 IF (UNIX)

=== bppSuite/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,10 @@
 TARGET_LINK_LIBRARIES(bppancestor ${LIBS})
 SET_TARGET_PROPERTIES(bppancestor PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})
 
+ADD_EXECUTABLE(bppmixedlikelihoods bppMixedLikelihoods.cpp)
+TARGET_LINK_LIBRARIES(bppmixedlikelihoods ${LIBS})
+SET_TARGET_PROPERTIES(bppmixedlikelihoods PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})
+
 ADD_EXECUTABLE(bppreroot bppReRoot.cpp)
 TARGET_LINK_LIBRARIES(bppreroot ${LIBS})
 SET_TARGET_PROPERTIES(bppreroot PROPERTIES LINK_SEARCH_END_STATIC ${BUILD_STATIC})
@@ -55,6 +59,7 @@
   bppseqman
   bppconsense
   bppancestor
+  bppmixedlikelihoods
   bppreroot
   bppphysamp
   bpptreedraw

=== doc/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Author: Julien Dutheil
# Created: 22/08/2009

IF(INFO)
  INSTALL(FILES bppsuite.info DESTINATION share/info)
ENDIF(INFO)

=== man/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Author: Julien Dutheil
# Created: 22/08/2009

IF(MAN)
  INSTALL(FILES bppml.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppseqgen.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppancestor.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bpppars.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppdist.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppconsense.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppseqman.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppreroot.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppphysamp.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bpptreedraw.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppalnscore.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
  INSTALL(FILES bppmixedlikelihoods.1.${DOC_COMPRESS_EXT} DESTINATION share/man/man1)
ENDIF(MAN)

=== debian/changelog ===
bppsuite (0.8.0-1+ubuntu1) wily; urgency=medium

  * Remove hardcoded library dependencies.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 11 Aug 2015 17:47:36 +0100

bppsuite (0.8.0-1+build1) unstable; urgency=low

  * New models for proteins (COaLA)
  * New program bppMixedLikelihoods

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Fri, 08 Mar 2013 11:41:00 +0100

bppsuite (0.7.0-1) unstable; urgency=low

  * Several program improvements (more models, options, etc.)
  * New program bpp Alignment scores.

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Wed, 15 Feb 2012 09:17:00 +0100

=== debian/control ===
Source: bppsuite
Section: science
Priority: optional
Maintainer: Loic Dachary <loic@dachary.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>
Build-Depends: debhelper (>= 5), cmake (>= 2.6), dpkg (>= 1.15.4) | install-info, texinfo,
  libbpp-phyl-dev (>= 2.0.3)
Standards-Version: 3.9.1

Package: bppsuite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Bio++ program suite
 Includes programs:
  - BppML for maximum likelihood analysis,
  - BppSeqGen for sequences simulation,
  - BppAncestor for ancestral states reconstruction,
  - BppDist for distance methods,
  - BppPars for parsimony analysis,
  - BppSeqMan for file conversion and sequence manipulation,
  - BppConsense for building consensus tree and computing bootstrap values,
  - BppPhySamp for phylogenetic sampling,
  - BppReRoot for tree rerooting.
  - BppTreeDraw for tree drawing.
  - BppAlnScore for comparing alignments and computing alignment scores.
  - BppMixedLikelihoods for computing site per site likelihoods of components of mixture models.

## bppsuite 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -203,9 +203,9 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "bppsuite")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "0.8.0")
-SET(CPACK_PACKAGE_VERSION_MAJOR "0")
-SET(CPACK_PACKAGE_VERSION_MINOR "8")
+SET(CPACK_PACKAGE_VERSION "2.2.0")
+SET(CPACK_PACKAGE_VERSION_MAJOR "2")
+SET(CPACK_PACKAGE_VERSION_MINOR "2")
 SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")

=== debian/changelog ===
bppsuite (2.2.0-0.1) unstable; urgency=low

  [ Andreas Beckmann ]
  * Non-maintainer upload.
  * New upstream release 2.2.0 (git commit 7890d12).
    (Closes: #776111, #825443, #708457)
  * Remove hardcoded library dependencies.  (Closes: #811271)

  [ Julien Dutheil ]
  * Compatibility update. Bio++ Program Suite version number is now indexed
    on Bio++'s version.
  * Programs support the --seed argument for setting the random seed.
  * bppSeqGen support generic characters as input.
  * bppPhySamp outputs sampled trees.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 10 Sep 2016 13:35:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Loic Dachary <loic@dachary.org>
 Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>
 Build-Depends: debhelper (>= 5), cmake (>= 2.6), dpkg (>= 1.15.4) | install-info, texinfo,
-  libbpp-phyl-dev (>= 2.0.3)
-Standards-Version: 3.9.1
+  libbpp-phyl-dev (>= 2.2.0)
+Standards-Version: 3.9.4
 
 Package: bppsuite
 Architecture: any

## bppsuite 2.3.1

=== CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 22/08/2009

cmake_minimum_required (VERSION 2.8.11)
project (bppsuite CXX)

# Compile options
SET (CMAKE_CXX_FLAGS "-std=c++11 -Wall -Weffc++ -Wshadow -Wconversion")

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(NOT NO_DEP_CHECK)
  SET(NO_DEP_CHECK FALSE CACHE BOOL
      "Disable dependencies check for building distribution only."
      FORCE)
ENDIF(NOT NO_DEP_CHECK)

IF(NO_DEP_CHECK)
  MESSAGE("-- Dependencies checking disabled. Only distribution can be built.")
ELSE(NO_DEP_CHECK)


#static linkage?
IF(NOT BUILD_STATIC)
  SET(BUILD_STATIC FALSE CACHE BOOL
      "Enable static linkage."
      FORCE)
ENDIF()
IF(BUILD_STATIC)
  MESSAGE("-- Static linkage requested.")
  SET(CMAKE_CXX_FLAGS "-static -static-libgcc ${CMAKE_CXX_FLAGS}")
ENDIF()

# Check compression program
# COMPRESS_PROGRAM controls the choice of program
# COMPRESS_EXT can be used to override the file extension
if (NOT COMPRESS_PROGRAM)
  set (COMPRESS_PROGRAM gzip CACHE STRING "Set program for compressing documentation" FORCE)
endif ()
find_program (COMPRESS_BIN NAMES ${COMPRESS_PROGRAM} DOC "${COMPRESS_PROGRAM} compression program")
if (NOT COMPRESS_BIN)
  message (STATUS "${COMPRESS_PROGRAM} program not found, text doc will not be compressed")
else ()
  # Deduce COMPRESS_EXT for known compression programs if not set
  if (NOT COMPRESS_EXT)
    if (${COMPRESS_PROGRAM} STREQUAL "gzip")
      set (COMPRESS_EXT "gz")
    elseif (${COMPRESS_PROGRAM} STREQUAL "bzip2")
      set (COMPRESS_EXT "bz2")
    else ()
      set (COMPRESS_EXT "${COMPRESS_PROGRAM}") # Default: program name (works for xz/lzma)
    endif ()
  endif ()
  # Generate command line args (always add -c to output compressed file to stdout)
  if (${COMPRESS_PROGRAM} STREQUAL "gzip")
    # -n for no timestamp in files (reproducible builds)
    set (COMPRESS_ARGS -c -n)
  else ()
    set (COMPRESS_ARGS -c)
  endif ()
  message (STATUS "Found ${COMPRESS_BIN} compression program, using file extension .${COMPRESS_EXT}")
endif ()

# Find dependencies (add install directory to search)
if (CMAKE_INSTALL_PREFIX)
  set (CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
endif (CMAKE_INSTALL_PREFIX)

include (GNUInstallDirs)
find_package (bpp-phyl 11.0.0 REQUIRED)
find_package (bpp-popgen 7.0.0 REQUIRED)

# Subdirectories
add_subdirectory (bppSuite)
add_subdirectory (doc)
add_subdirectory (man)

ENDIF(NO_DEP_CHECK)

# Packager
SET(CPACK_PACKAGE_NAME "bppsuite")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "2.3.1")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "3")
SET(CPACK_PACKAGE_VERSION_PATCH "1")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
# /!\ This assumes that an external build is used
SET(CPACK_SOURCE_IGNORE_FILES 
       "/build/" 
       "/\\\\.git/" 
       "/\\\\.gitignore" 
       ${CPACK_SOURCE_IGNORE_FILES}
       )

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF(NOT NO_DEP_CHECK)
IF (UNIX)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist info man)

#ADD_DEPENDENCIES(info install)

ENDIF(UNIX)

ENDIF(NOT NO_DEP_CHECK)

=== bppSuite/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 22/08/2009

# Executables of bppsuite.
# Generation of targets from file name is not automated in case of executables not following the pattern.
add_executable (bppml bppML.cpp)
add_executable (bppseqgen bppSeqGen.cpp)
add_executable (bppdist bppDist.cpp)
add_executable (bpppars bppPars.cpp)
add_executable (bppseqman bppSeqMan.cpp)
add_executable (bppconsense bppConsense.cpp)
add_executable (bppancestor bppAncestor.cpp)
add_executable (bppmixedlikelihoods bppMixedLikelihoods.cpp)
add_executable (bppreroot bppReRoot.cpp)
add_executable (bpptreedraw bppTreeDraw.cpp)
add_executable (bppalnscore bppAlnScore.cpp)
add_executable (bpppopstats bppPopStats.cpp)

set (bppsuite-targets
  bppml
  bppseqgen
  bppdist
  bpppars
  bppseqman
  bppconsense
  bppancestor
  bppmixedlikelihoods
  bppreroot
  bpptreedraw
  bppalnscore
  bpppopstats
  )

foreach (target ${bppsuite-targets})
  # Link (static or shared)
  if (BUILD_STATIC)
    target_link_libraries (${target} ${BPP_LIBS_STATIC})
    set_target_properties (${target} LINK_SEARCH_END_STATIC TRUE)
  else (BUILD_STATIC)
    target_link_libraries (${target} ${BPP_LIBS_SHARED})
  endif (BUILD_STATIC)
endforeach (target)

install (TARGETS ${bppsuite-targets} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
bppsuite (2.3.1-3) unstable; urgency=medium

  * Fixed linkage issue in x32 arch (second attempt) 

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Wed, 19 Jul 2017 20:56:28 +0200

bppsuite (2.3.1-2) unstable; urgency=medium

  * Fixed linkage issue in x32 arch. 

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Tue, 18 Jul 2017 21:47:05 +0200

bppsuite (2.3.1-1) unstable; urgency=medium

  * New upstream version
  * Take over to Debian Med team maintenance
  * cme fix dpkg-control
  * debhelper 10
  * DEP5
  * Add watch file
  * d/rules: use dh
  * Fix manpage debhelper input
  * Adjust Build-Depends
  * Enhance description
  * Add examples package

 -- Andreas Tille <tille@debian.org>  Wed, 14 Jun 2017 15:12:35 +0200

=== debian/control ===
Source: bppsuite
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               texinfo,
               libbpp-phyl-dev (>= 2.3.1),
               libbpp-popgen-dev (>= 2.3.1),
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bppsuite.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/bppsuite.git
Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page

Package: bppsuite
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: bppsuite-examples
Description: Bio++ program suite
 The Bio++ Program Suite is a package of programs using the Bio++
 libraries and dedicated to Phylogenetics and Molecular Evolution.  All
 programs are independent, but can be combined to perform rather complex
 analyses.  These programs use the interface helper tools of the
 libraries, and hence share the same syntax.  They also have several
 options in common, which may also be shared by third-party software.
 .
 The following programs are included:
  - BppML for maximum likelihood analysis,
  - BppSeqGen for sequences simulation,
  - BppAncestor for ancestral states reconstruction,
  - BppDist for distance methods,
  - BppPars for parsimony analysis,
  - BppSeqMan for file conversion and sequence manipulation,
  - BppConsense for building consensus tree and computing
    bootstrap values,
  - BppPhySamp for phylogenetic sampling,
  - BppReRoot for tree rerooting.
  - BppTreeDraw for tree drawing.
  - BppAlnScore for comparing alignments and computing alignment scores.
  - BppMixedLikelihoods for computing site per site likelihoods of
    components of mixture models.

Package: bppsuite-examples
Architecture: all
Depends: ${misc:Depends}
Enhances: bppsuite
Description: Examples for Bio++ program suite
 The Bio++ Program Suite is a package of programs using the Bio++
 libraries and dedicated to Phylogenetics and Molecular Evolution.  All
 programs are independent, but can be combined to perform rather complex
 analyses.  These programs use the interface helper tools of the
 libraries, and hence share the same syntax.  They also have several
 options in common, which may also be shared by third-party software.
 .
 This package contains some example data sets.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_fixperms:
	dh_fixperms
	find debian -name "*.dnd" -exec chmod -x \{\} \;

## bppsuite 2.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,7 +61,8 @@
   # Generate command line args (always add -c to output compressed file to stdout)
   if (${COMPRESS_PROGRAM} STREQUAL "gzip")
     # -n for no timestamp in files (reproducible builds)
-    set (COMPRESS_ARGS -c -n)
+    # -9 for maximum compression (lintian error)
+    set (COMPRESS_ARGS -c -n -9)
   else ()
     set (COMPRESS_ARGS -c)
   endif ()
@@ -74,8 +75,8 @@
 endif (CMAKE_INSTALL_PREFIX)
 
 include (GNUInstallDirs)
-find_package (bpp-phyl 11.0.0 REQUIRED)
-find_package (bpp-popgen 7.0.0 REQUIRED)
+find_package (bpp-phyl 12.0.0 REQUIRED)
+find_package (bpp-popgen 8.0.0 REQUIRED)
 
 # Subdirectories
 add_subdirectory (bppSuite)
@@ -87,10 +88,10 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "bppsuite")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "2.3.1")
+SET(CPACK_PACKAGE_VERSION "2.4.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "3")
-SET(CPACK_PACKAGE_VERSION_PATCH "1")
+SET(CPACK_PACKAGE_VERSION_MINOR "4")
+SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Program Suite")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")

=== doc/CMakeLists.txt ===
# CMake script for Bio++ Program Suite
# Authors:
#   Julien Dutheil
#   Francois Gindraud (2017)
# Created: 22/08/2009

# Builds info, html, pdf doc.
# Info doc is built and install as part of "all" if makeinfo is found.
# Html doc is proposed as a "html" optional target if makeinfo is found.
# Pdf doc is proposed as a "pdf" optional target if makeinfo AND texi2dvi are found.

find_program (MAKEINFO NAMES makeinfo texi2any DOC "makeinfo doc generator program")
if (NOT MAKEINFO)
  message (STATUS "makeinfo program not found: 'info' and 'html' target disabled (builds info/html doc)")
else ()
  message (STATUS "Found ${MAKEINFO}: 'info' and 'html' target enabled (builds info/html doc)")

  set (input ${CMAKE_CURRENT_SOURCE_DIR}/bppsuite.texi)

  # Build info page
  set (output ${CMAKE_CURRENT_BINARY_DIR}/bppsuite.info)
  add_custom_command (
    OUTPUT ${output}
    COMMAND ${MAKEINFO} --no-split -o ${output} ${input}
    DEPENDS ${input}
    COMMENT "Generating info page"
    VERBATIM
    )

  # Install, and have "info" built with "all" (install needs the file to be built)
  if (NOT COMPRESS_BIN)
    # Install uncompressed info page
    install (FILES ${output} DESTINATION ${CMAKE_INSTALL_INFODIR})
    add_custom_target (info ALL DEPENDS ${output})
  else ()
    # Compress and install compressed file
    set (compressed_ouput ${output}.${COMPRESS_EXT})
    add_custom_command (
      OUTPUT ${compressed_ouput}
      COMMAND ${COMPRESS_BIN} ${COMPRESS_ARGS} ${output} > ${compressed_ouput}
      DEPENDS ${output}
      COMMENT "Compressing info page"
      VERBATIM
      )
    install (FILES ${compressed_ouput} DESTINATION ${CMAKE_INSTALL_INFODIR})
    add_custom_target (info ALL DEPENDS ${compressed_ouput})
  endif ()

  # Also provide a "html" target that builds html doc (not installed, and not part of "all").
  set (output ${CMAKE_CURRENT_BINARY_DIR}/bppsuite.html)
  set (makeinfo-css "http://www.w3.org/StyleSheets/Core/Steely")
  add_custom_command (
    OUTPUT ${output}
    COMMAND ${MAKEINFO} --html --css-ref=${makeinfo-css} --no-split -o ${output} ${input}
    DEPENDS ${input}
    COMMENT "Generating html doc"
    VERBATIM
    )
  add_custom_target (html DEPENDS ${output})

  # Provide a "pdf" target that builds pdf doc (not installed, not part of "all").
  find_program (TEXIDVI NAMES texi2dvi)
  if (TEXIDVI)
    message (STATUS "Found texi2dvi: 'pdf' target enabled (builds pdf doc)")
    set (output ${CMAKE_CURRENT_BINARY_DIR}/bppsuite.pdf)
    add_custom_command (
      OUTPUT ${output}
      COMMAND ${MAKEINFO} --pdf --Xopt=--clean -o ${output} ${input}
      DEPENDS ${input}
      COMMENT "Generating pdf doc"
      VERBATIM
      )
    add_custom_target (pdf DEPENDS ${output})
  endif ()
endif ()

=== debian/changelog ===
bppsuite (2.4.0-1) unstable; urgency=medium

  [ Julien Dutheil ]
  * New upstream version
  * Added full text of CeCILL license.
  * Compiles with -DCMAKE_BUILD_TYPE=RelWithDebInfo to generate debug info
    (lintian warning)
  * Point Vcs-fields to salsa.debian.org

  [ Andreas Tille ]
  * Standards-Version: 4.1.4

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Tue, 10 Apr 2018 14:53:00 +0200

bppsuite (2.3.2-1) unstable; urgency=medium

  [ Julien Dutheil ]
  * New upstream version

  [ Steffen Moeller ]
  * debian/upstream/metadata; added reference to registries

  [ Andreas Tille ]
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Wed, 07 Feb 2018 11:28:09 +0200

bppsuite (2.3.1-4) unstable; urgency=medium

  * Add debhelper install file
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Tue, 12 Sep 2017 15:01:42 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                cmake,
                texinfo,
-               libbpp-phyl-dev (>= 2.3.1),
-               libbpp-popgen-dev (>= 2.3.1),
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bppsuite.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/bppsuite.git
+               libbpp-phyl-dev (>= 2.4.0),
+               libbpp-popgen-dev (>= 2.4.0)
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/med-team/bppsuite
+Vcs-Git: https://salsa.debian.org/med-team/bppsuite.git
 Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page
 
 Package: bppsuite
@@ -36,12 +36,12 @@
   - BppSeqMan for file conversion and sequence manipulation,
   - BppConsense for building consensus tree and computing
     bootstrap values,
-  - BppPhySamp for phylogenetic sampling,
   - BppReRoot for tree rerooting.
   - BppTreeDraw for tree drawing.
   - BppAlnScore for comparing alignments and computing alignment scores.
   - BppMixedLikelihoods for computing site per site likelihoods of
     components of mixture models.
+  - BppPopGen for population genetics analyses.
 
 Package: bppsuite-examples
 Architecture: all
